﻿
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using More.Engine;
using More.Engine.Evaluation;
using More.Engine.Model;
namespace Rules4242013
{
    public class CompiledRuleBookFactory : CompiledRuleBookFactoryBase
    {
        public override CompiledRuleBookBase GetRuleBook(string name)
        {

            if (name.Equals("MikesTestBook"))
            {
                return new MikesTestBookRuleBook();
            }
            if (name.Equals("CCI_TierFactor"))
            {
                return new CCI_TierFactorRuleBook();
            }
            return null;
        }
    }


    public class MikesTestBookRuleBook : CommonRuleBook
    {
        public override InputRequirement[] GetInputRequirements()
        {
            return new[] { new InputRequirement() { Name = "age" } };
            return new[] { new InputRequirement() { Name = "points" } };
        }
        protected override RuleBookResult InternalExecute(Dictionary<string, object> inputs)
        {


            if (true)
            {
                ConditionEntered("DriverValidation");
                var age = GetInput("age");
                var points = GetInput("points");

                var AgeCheck =
                    StatementExecuted("17", "AgeCheck", "AgeCheck", "age <= 70 and age > 17",
                         () => { return Convert.ToBoolean((Convert.ToDouble((age)) <= Convert.ToDouble(70))) && Convert.ToBoolean((Convert.ToDouble((age)) > Convert.ToDouble(17))); } // <------- AgeCheck
                         );


                var PointsCheck =
                    StatementExecuted("19", "PointsCheck", "PointsCheck", "points <= 7",
                         () => { return Convert.ToDouble((points)) <= Convert.ToDouble(7); } // <------- PointsCheck
                         );


                var Final =
                    StatementExecuted("15", "Final", "Final", "AgeCheck and PointsCheck",
                         () => { return Convert.ToBoolean((AgeCheck)) && Convert.ToBoolean((PointsCheck)); } // <------- Final
                         );

                ConditionExited("DriverValidation");
            }

            return Result;
        }
    }
    public class CCI_TierFactorRuleBook : CommonRuleBook
    {
        public override InputRequirement[] GetInputRequirements()
        {
            return new[] { new InputRequirement() { Name = "insuredCreditScore" } };
            return new[] { new InputRequirement() { Name = "age" } };
            return new[] { new InputRequirement() { Name = "yearsExperience" } };
            return new[] { new InputRequirement() { Name = "numberOfMinors" } };
            return new[] { new InputRequirement() { Name = "numberOfPoints" } };
            return new[] { new InputRequirement() { Name = "yearsWithCurrentEmployer" } };
            return new[] { new InputRequirement() { Name = "referenceId" } };
            return new[] { new InputRequirement() { Name = "drivers" } };
        }
        protected override RuleBookResult InternalExecute(Dictionary<string, object> inputs)
        {


            if (true)
            {
                ConditionEntered("CalculateTierFactor");
                var insuredCreditScore = GetInput("insuredCreditScore");
                var drivers = GetInput("drivers");

                var CreditTier =
                    StatementExecuted("30", "CreditTier", "CreditTier", "CCI_CreditTier(\'Tier\', insuredCreditScore)",
                         () => CCI_CreditTier("Tier", insuredCreditScore) 
// <------- CreditTier
                         );


                var Drivers = GetInput("drivers");
                if (true)
                {
                    ConditionEntered("Drivers");
                    LoopEntered("Drivers", "drivers");
                    drivers = GetInput("drivers");

                    var DriversItemIndex = 0;
                    foreach (IDictionary<string, object> DriversItem in (IList)drivers)
                    {
                        LoopItemEntered(DriversItemIndex, "Drivers", "drivers", DriversItem);
                        var age = GetInput("age");
                        var yearsExperience = GetInput("yearsExperience");
                        var numberOfMinors = GetInput("numberOfMinors");
                        var numberOfPoints = GetInput("numberOfPoints");
                        var yearsWithCurrentEmployer = GetInput("yearsWithCurrentEmployer");
                        var referenceId = GetInput("referenceId");

                        var AgeTier =
                            StatementExecuted("29", "AgeTier", "AgeTier", "CCI_AgeTier(\'Tier\', age)",
                                 () => { return CCI_AgeTier("Tier", age); } // <------- AgeTier
                                 );


                        var DrivingExperienceTier =
                            StatementExecuted("31", "DrivingExperienceTier", "DrivingExperienceTier", "CCI_DrivingExpTier(\'Tier\', yearsExperience)",
                                 () => { return CCI_DrivingExpTier("Tier", yearsExperience); } // <------- DrivingExperienceTier
                                 );


                        var NumberOfMinorsTier =
                            StatementExecuted("32", "NumberOfMinorsTier", "NumberOfMinorsTier", "numberOfMinors > 0 ? CCI_NumberMinorsTier(\'Tier\', numberOfMinors) : 3",
                                 () => { return (bool)(Convert.ToDouble((numberOfMinors)) > Convert.ToDouble(0)) ? (CCI_NumberMinorsTier("Tier", numberOfMinors)) : 3; } // <------- NumberOfMinorsTier
                                 );


                        var NumberOfPointsTier =
                            StatementExecuted("33", "NumberOfPointsTier", "NumberOfPointsTier", "numberOfPoints > 0 ? CCI_NumberPointsTier(\'Tier\', numberOfPoints) : 3",
                                 () => { return (bool)(Convert.ToDouble((numberOfPoints)) > Convert.ToDouble(0)) ? (CCI_NumberPointsTier("Tier", numberOfPoints)) : 3; } // <------- NumberOfPointsTier
                                 );


                        var YearsWithCurrentEmployerTier =
                            StatementExecuted("34", "YearsWithCurrentEmployerTier", "YearsWithCurrentEmployerTier", "CCI_YearsWithCurrentEmployerTier(\'Tier\', yearsWithCurrentEmployer)",
                                 () => { return CCI_YearsWithCurrentEmployerTier("Tier", yearsWithCurrentEmployer); } // <------- YearsWithCurrentEmployerTier
                                 );


                        var CorrelationId =
                            StatementExecuted("35", "CorrelationId", "CorrelationId", "referenceId",
                                 () => { return referenceId; } // <------- CorrelationId
                                 );


                        var TierAverage =
                            StatementExecuted("28", "TierAverage", "TierAverage", "(AgeTier + CreditTier + DrivingExperienceTier + NumberOfMinorsTier + NumberOfPoin" +
                    "tsTier + YearsWithCurrentEmployerTier) / 6",
                                 () => { return Convert.ToDouble((Convert.ToDouble((Convert.ToDouble((Convert.ToDouble((Convert.ToDouble((Convert.ToDouble((AgeTier)) + Convert.ToDouble((CreditTier)))) + Convert.ToDouble((DrivingExperienceTier)))) + Convert.ToDouble((NumberOfMinorsTier)))) + Convert.ToDouble((NumberOfPointsTier)))) + Convert.ToDouble((YearsWithCurrentEmployerTier)))) / Convert.ToDouble(6); } // <------- TierAverage
                                 );

                        LoopItemExited(DriversItemIndex, "Drivers", "drivers");
                        DriversItemIndex++;
                    }
                    LoopExited("Drivers", "drivers");
                    ConditionExited("Drivers");
                }


                var OverallAverageTier =
                    StatementExecuted("42", "OverallAverageTier", "OverallAverageTier", "Sum(drivers, \'TierAverage\') / Count(drivers)",
                         () => { return Convert.ToDouble((Sum(drivers, "TierAverage"))) / Convert.ToDouble((Count(drivers))); } // <------- OverallAverageTier
                         );


                var OverallTier =
                    StatementExecuted("43", "OverallTier", "OverallTier", "Round(OverallAverageTier, 0)",
                         () => { return Round(OverallAverageTier, 0); } // <------- OverallTier
                         );


                var TierFactorTier =
                    StatementExecuted("39", "TierFactorTier", "TierFactorTier", "CCI_TierFactor(\'Factor\', OverallTier)",
                         () => { return CCI_TierFactor("Factor", OverallTier); } // <------- TierFactorTier
                         );


                var TierAdjustmentFactor =
                    StatementExecuted("40", "TierAdjustmentFactor", "TierAdjustmentFactor", "CCI_TierAdjustmentFactor(\'Factor\', TierFactorTier-OverallTier)",
                         () => { return CCI_TierAdjustmentFactor("Factor", Convert.ToDouble((TierFactorTier)) - Convert.ToDouble((OverallTier))); } // <------- TierAdjustmentFactor
                         );


                var TierFactor =
                    StatementExecuted("41", "TierFactor", "TierFactor", "TierFactorTier * TierAdjustmentFactor",
                         () => { return Convert.ToDouble((TierFactorTier)) * Convert.ToDouble((TierAdjustmentFactor)); } // <------- TierFactor
                         );

                ConditionExited("CalculateTierFactor");
            }

            return Result;
        }
    }
    public class CommonRuleBook : CompiledRuleBookBase
    {
        public override InputRequirement[] GetInputRequirements()
        {
            return null;
        }
        protected override RuleBookResult InternalExecute(Dictionary<string, object> inputs)
        {

            return Result;
        }



        public virtual object FactorTableA(string column, object _Key)
        {

            if (
                                                ExactMatch(_Key, "LCM".ToLower())

                            )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.4;
                }

            }
            if (
                                        ExactMatch(_Key, "BOB".ToLower())

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 5;
                }

            }

            return null;
        }



        public virtual object FactorTableB(string column, object _Key)
        {

            if (
                                                ExactMatch(_Key, "Bob".ToLower())

                            )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 4;
                }

            }
            if (
                                        ExactMatch(_Key, "Joe".ToLower())

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 5;
                }

            }

            return null;
        }



        public virtual object Derp(string column, object _KeyCol)
        {

            if (
                                                          GreaterThanOrEqual(_KeyCol, 5)

                            )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 4.3;
                }

            }

            return null;
        }



        public virtual object CCI_AgeTier(string column, object _Age)
        {

            if (
                                                           LessThanOrEqual(_Age, 27)

                            )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 5;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 34)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 39)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 44)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 55)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 1;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 64)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 69)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 74)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_Age, 999)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 5;
                }

            }

            return null;
        }



        public virtual object CCI_CreditTier(string column, object _CreditScore)
        {

            if (
                                                           LessThanOrEqual(_CreditScore, 399)

                            )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "I".ToLower();
                    case "TIER":
                        return 5;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 499)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "H".ToLower();
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 599)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "G".ToLower();
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 649)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "F".ToLower();
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 699)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "E".ToLower();
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 749)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "D".ToLower();
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 799)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "C".ToLower();
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 849)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "B".ToLower();
                    case "TIER":
                        return 1;
                }

            }
            if (
                                                   LessThanOrEqual(_CreditScore, 997)

                    )
            {

                switch (column.ToUpper())
                {
                    case "CREDITTIER":
                        return "A".ToLower();
                    case "TIER":
                        return 1;
                }

            }

            return null;
        }



        public virtual object CCI_DrivingExpTier(string column, object _YearsExperience)
        {

            if (
                                                           LessThanOrEqual(_YearsExperience, 4)

                            )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 5;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsExperience, 9)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsExperience, 14)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsExperience, 19)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsExperience, 999)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 1;
                }

            }

            return null;
        }



        public virtual object CCI_NumberMinorsTier(string column, object _NumberOfMinors)
        {

            if (
                                                           LessThanOrEqual(_NumberOfMinors, 1)

                            )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 1;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfMinors, 2)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfMinors, 3)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfMinors, 4)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfMinors, 999)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 5;
                }

            }

            return null;
        }



        public virtual object CCI_NumberPointsTier(string column, object _NumberOfPoints)
        {

            if (
                                                           LessThanOrEqual(_NumberOfPoints, 1)

                            )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 1;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfPoints, 3)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfPoints, 5)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfPoints, 7)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_NumberOfPoints, 999)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 5;
                }

            }

            return null;
        }



        public virtual object CCI_TierAdjustmentFactor(string column, object _Fit)
        {

            if (
                                                           LessThanOrEqual(_Fit, -0.5)

                            )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.8219;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, -0.4)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.8548;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, -0.3)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.889;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, -0.2)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.9246;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, -0.1)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.9615;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, 0)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, 0.1)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.04;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, 0.2)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.0816;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, 0.3)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.1249;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, 0.4)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.1699;
                }

            }
            if (
                                                   LessThanOrEqual(_Fit, 0.5)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.1267;
                }

            }

            return null;
        }



        public virtual object CCI_TierFactor(string column, object _Tier)
        {

            if (
                                                ExactMatch(_Tier, 1)

                            )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.4445;
                }

            }
            if (
                                        ExactMatch(_Tier, 2)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 0.6667;
                }

            }
            if (
                                        ExactMatch(_Tier, 3)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1;
                }

            }
            if (
                                        ExactMatch(_Tier, 4)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 1.5;
                }

            }
            if (
                                        ExactMatch(_Tier, 5)

                    )
            {

                switch (column.ToUpper())
                {
                    case "FACTOR":
                        return 2.25;
                }

            }

            return null;
        }



        public virtual object CCI_YearsWithCurrentEmployerTier(string column, object _YearsWithCurrentEmployer)
        {

            if (
                                                           LessThanOrEqual(_YearsWithCurrentEmployer, 2)

                            )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 5;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsWithCurrentEmployer, 5)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 4;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsWithCurrentEmployer, 8)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 3;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsWithCurrentEmployer, 10)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 2;
                }

            }
            if (
                                                   LessThanOrEqual(_YearsWithCurrentEmployer, 999)

                    )
            {

                switch (column.ToUpper())
                {
                    case "TIER":
                        return 1;
                }

            }

            return null;
        }
    }
}