using System;
using More.Engine.CodeGen;
using NCalc;

namespace More.Engine.Compiling
{
    /// <summary>
    /// A model class for rating engine 'Exceptions'. Very similar to a rating-rule. 
    /// But, does not have a tree-like structure
    /// </summary>
    public class RuleBookModel
    {
        private string[] _inputs;

        public RuleBookModel()
        {
        }

        public string Id { get; set; }
        public string Name { get; set; }
        public string ChangeId { get; set; }
        public DateTime EffectiveDate { get; set; }
        public bool Active { get; set; }

        public RuleBookModel(string id, string name, string changeId, DateTime effectiveDate)
        {
            Id = id;
            Name = name;
            ChangeId = changeId;
            EffectiveDate = effectiveDate;
        }
       
    }
}