using System;
using System.Collections.Generic;

namespace More.Engine.Model
{
    /// <summary>
    /// Definition model class of a factor table column/key definition
    /// </summary>
    public class FactorTableColumnDefinition
    {
        public int ID { get; set; }
        public Guid ChangeId { get; set; }
        public Guid FactorTableChangeId { get; set; }
        public string Name { get; set; }
        public bool IsKey { get; set; }
        public LookupType LookupType { get; set; }
        private Dictionary<string, object> _properties;
        public Dictionary<string, object> Properties
        {
            get { return _properties ?? (_properties = new Dictionary<string, object>()); }
            set { _properties = value; }
        }

        

        public FactorTableColumnDefinition()
        {
        }

        public FactorTableColumnDefinition(string name, bool isKey)
        {
            Name = name;
            IsKey = isKey;
        }

        public FactorTableColumnDefinition(int id, Guid changeId, Guid factorTableChangeId, string name, bool isKey)
        {
            ID = id;
            ChangeId = changeId;
            FactorTableChangeId = factorTableChangeId;
            Name = name;
            IsKey = isKey;
        }
    }
}