using System.Collections.Generic;
using More.Engine.Model;

namespace More.Application.BaseModel
{
    public interface ILookupTablesRepository
    {
        IEnumerable<LookupTableModel> GetRatingTables();

        LookupTableModel GetRatingTableModel(string id);
        void SaveRatingTableModel(LookupTableModel model);
        void SaveLookupTableKey(LookupTableKeyModel model);
       // void SaveRatingTableColumn(LookupTableColumnModel model);
        void SaveLookupTableRow(LookupTableRowModel model);

        LookupTableKeyModel GetLookupTableKey(string tableName, string tableId, string tableColumn);
        //LookupTableColumnModel GetRatingTableColumn(int id);
        LookupTableRowModel GetLookupTableRow(string lookupTableName,string lookupTableId, string rowId);

        void DeleteLookupTableKey(int id);
        void DeleteRateTableColumn(int id);
        void DeleteLookupTableRow(string tableName, string tableId, string rowId);
        LookupTable GetLookupTable(string id);
        void ImportTables(IEnumerable<LookupTable> importTables, bool drop);
    }
}