using System;
using System.Collections.Generic;
using System.Reflection;
using More.Engine.BaseModel;
using More.Engine.Compiling;
using More.Engine.Model;

namespace More.Application.BaseModel
{
    public interface IRulesEngineRepository
    {
        RuleEngineRule GetRule(int ruleId);
        void DeleteRule(int id);
        Assembly GetRatingAssembly(string assemblyPath, string assemblyName, DateTime effectiveDate);
        void SaveRuleAssembly(string assemblyName, DateTime effectiveDate);
        void SaveRuleBook(RuleBookModel model);
        void DeleteRuleBook(int id);
        RuleBookModel GetRuleBook(int id);
        IEnumerable<RuleBookAssemblyModel> GetRatingAssemblies();
        IEnumerable<RuleBookModel> GetRuleBooks();
        IEnumerable<RuleEngineRule> GetRuleBookRules(int ruleBookId, Predicate<RuleEngineRule> filter = null, bool validate = true);

        void PublishRatingAssembly(DateTime date);
        void SaveRule(RuleEngineRule ratingRule);
        
    }
}